/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPWorkflowAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;


import jp.mosp.workflow.dto.AmRouteDto;
import jp.mosp.workflow.dto.PmAttendanceDto;
import jp.mosp.workflow.vo.AttendanceRouteCardVo;

public class AttendanceRouteCardAction extends MosPWorkflowAction {

	// コマンド
	private static final String CMD_ROUTE_CARD_SHOW   = "S2835";	// 表示(追加)
	private static final String CMD_ROUTE_CARD_SELECT = "S2836";	// 表示(選択)
	private static final String CMD_ROUTE_CARD_INSERT = "S2837";	// 登録
	private static final String CMD_ROUTE_CARD_UPDATE = "S2838";	// 更新

	/**
	 * コンストラクタ
	 */
	public AttendanceRouteCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		AttendanceRouteCardVo vo = new AttendanceRouteCardVo();
		vo.clearMessage();
		vo.clearErrField();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DAOの宣言
		preparePmAttendanceDao();
		// DTOの取得
		PmAttendanceDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof PmAttendanceDto ? (PmAttendanceDto)obj : null;
		// プルダウンのセット
		setPulldownList(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_ROUTE_CARD_SHOW)) {
			vo.setDefaultValues();
			// モード設定
			setMode(vo);	
		} else if (cmd.equals(CMD_ROUTE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = pmAttendDao.findForKey(key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROUTE_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROUTE_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * プルダウンの設定
	 * @param vo
	 * @throws Exception
	 */
	private void setPulldownList(AttendanceRouteCardVo vo) throws Exception {
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// 所属コード一覧
		vo.aryPltSection = util.addArrayFirstRowSpace(getSectionArrayAll());
		// 勤怠用承認ルートコード一覧
		vo.aryPltRoute	= getRouteArrayAvailable();
		// 人事基本情報
		vo.aryUser	= getBasisArrayAll();
		// 所属確認用配列
		vo.aryBelong = getBasisArrayAllWithSectionCode();
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private PmAttendanceDto insert(AttendanceRouteCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		preparePmAttendanceDao();
		// 存在チェック
		chkDuplicate(pmAttendDao.findForCondition(vo.getPltSection(), vo.getTxtKCode(), vo.getPltRouteCode()), vo);
		if (!vo.getTxtKCode().equals("")) {
			chkDuplicate(pmAttendDao.findForKCode(vo.getTxtKCode()), vo);
		}
		// 最大値をセット
		String maxEno =	pmAttendDao.findForMax();
		if (maxEno == null || maxEno.equals("")) {
			maxEno = "-1";
		} else {
			pmAttendDao.findForUpdate(maxEno);
		}
		// DTOの準備
		PmAttendanceDto dto = new PmAttendanceDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		dto.setRouteId(Integer.parseInt(maxEno) + 1);
		// データの挿入
		pmAttendDao.insert(dto);
		// DTOの再取得
		dto = pmAttendDao.findForKey(String.valueOf(dto.getRouteId()));
		// コミット
		commit();
		// モード設定
		vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private PmAttendanceDto update(AttendanceRouteCardVo vo, PmAttendanceDto dto) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		preparePmAttendanceDao();
		// 排他確認
		chkExclusive(dto, pmAttendDao.findForUpdate(vo.getHidRouteid()), vo);
		// 最大値をセット
		String maxEno =	pmAttendDao.findForMax();
		if(maxEno == null || maxEno.equals("")){
			maxEno = "-1";
		} else {
			pmAttendDao.findForUpdate(maxEno);
		}
		if (pmAttendDao.findForUpdate(String.valueOf(dto.getRouteId())) != null) {
			dto.setDeleteFlag(MospConst.DELETE_FLAG_ON);
			// 論理削除
			pmAttendDao.update(dto);
		}
		// DTOの準備
		vo.setDtoFields(dto);
		dto.setRouteId(Integer.parseInt(maxEno) + 1);
		// データの更新
		pmAttendDao.insert(dto);
		// DTOの再取得
		PmAttendanceDto retDto = pmAttendDao.findForKey(String.valueOf(dto.getRouteId()));
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * 勤怠用承認ルートコード一覧（一次、最終）
	 * @return	String[][]	ルートコード配列
	 * @throws Exception
	 */
	private String[][] getRouteArrayAvailable() throws Exception {
		// DAOの準備
		prepareAmRouteDao();
		// 情報の取得
		List<AmRouteDto> listRoute = routeDao.findForAttendanceRoute();
		// 配列の作成		
		String[][] aryRouteList = new String[listRoute.size()][2];
		String[][] aryUnit = getCurrentUnitArray();
		for (int i = 0; i < listRoute.size(); i++) {
			aryRouteList[i][0] = listRoute.get(i).getRtCode();
			StringBuffer sb = new StringBuffer();
			sb.append(CommonConst.MSG_APPROVAL_FIRST);
			sb.append(util.getCodeName(listRoute.get(i).getLayer1(), aryUnit));
			sb.append(CommonConst.MSG_APPROVAL_SECOND);
			sb.append(util.getCodeName(listRoute.get(i).getLastLayer(), aryUnit));
			aryRouteList[i][1] = sb.toString();
		}
		return aryRouteList;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(AttendanceRouteCardVo vo) throws Exception {
		// モード設定
		if (vo.aryPltRoute.length == 0) {
			vo.setMode(AttendanceRouteCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(AttendanceRouteCardVo.MODE_INSERT);
		}
	}

}
